// -*- c++ -*- tell emacs what this is C++.  Important if .h is used for the file name
/** @file
    @brief Autogenerated source file defining the parameter class
 */

#ifndef _ALLTYPES_H_ // include guard
#define _ALLTYPES_H_

#include <string>
#include <vector>

/**
  @brief Autogenerated parameter container

  This class contains the parameters needed for a range of
  applications.  The file is AUTOGENERATED.  Do NOT edit.
*/
class AllTypes {
public:
   /** @brief parameter class that allows for command line options and config files.

   All is used for writing all values.
   Set means that variable was set by one of a set method
   */

    AllTypes(void) {};  ///< Initialize without defaults
    AllTypes(const bool useDefaults); ///< Initialize with/without the defaults
    AllTypes(const int argc, char * const *argv);  ///< Initialize from command line args
    ~AllTypes(void) {};  ///< Initialize without defaults.  FIX: does this need more?

    void init(); ///< Set the class to an initial state of unknown
    void defaults(); ///< Set the class to an initial state

   // FIX: implement these two
    bool save(const std::string &filename) const; ///< Write xml of parameters to a file, but use only the listed source
    bool load(const std::string &filename); ///< Read parameters from an xml file

    void print(); ///< Dump to stdout



    ////////////////////////////////////////
    //  Catagory: bools
    ////////////////////////////////////////


    ////////////////////
    /** @defgroup myBool A demonstration flag
A single bool or flag.  This is where you can write a 
    @{
    */
public:
    /*!
     @brief A demonstration flag
     
     Attributes:
       - Name: My bool
       - Short Option:b
       - Long Option:my-bool
       - Default: False
       - Units: None
     
     
     A single bool or flag.  This is where you can write a 
     */
    bool myBool;
    /** @} */ // End of myBool group

    ////////////////////////////////////////
    //  Catagory: ints
    ////////////////////////////////////////


    ////////////////////
    /** @defgroup myInt Example of an integer
Simple integer
    @{
    */
public:
    /*!
     @brief Example of an integer
     
     Attributes:
       - Name: myInt
       - Short Option:i
       - Long Option:int
       - Default: 0
       - Units: m
     
     
     Simple integer
     */
    int myInt;
    /** @} */ // End of myInt group

    ////////////////////
    /** @defgroup intArray Specify this option multiple times for an array of integers
Simple array of integers
    @{
    */
public:
    inline void appendIntarray(const int &newVal) {intArray.push_back(newVal);} ///< Add an entry on the end
    inline void    popIntarray() {intArray.pop_back();} ///< Remove last entry
    inline void   sizeIntarray() {intArray.size();} ///< Length of the array
    /*!
     @brief Specify this option multiple times for an array of integers
     
     Attributes:
       - Name: Int Array
       - Short Option:I
       - Long Option:int-array
       - Default: None
       - Units: count
     
     
     Simple array of integers
     */
    std::vector<int> intArray;
    /** @} */ // End of intArray group

    ////////////////////////////////////////
    //  Catagory: floats
    ////////////////////////////////////////


    ////////////////////
    /** @defgroup myFloat A simple float.
Simple float.  This value is unitless
    @{
    */
public:
    /*!
     @brief A simple float.
     
     Attributes:
       - Name: myFloat
       - Short Option:f
       - Long Option:float
       - Default: -123.4
       - Units: None
     
     
     Simple float.  This value is unitless
     */
    float myFloat;
    /** @} */ // End of myFloat group

    ////////////////////
    /** @defgroup floatArray FIX: add short description here
Simple array of floats.  This shows having units
    @{
    */
public:
    inline void appendFloatarray(const float &newVal) {floatArray.push_back(newVal);} ///< Add an entry on the end
    inline void    popFloatarray() {floatArray.pop_back();} ///< Remove last entry
    inline void   sizeFloatarray() {floatArray.size();} ///< Length of the array
    /*!
     @brief FIX: add short description here
     
     Attributes:
       - Name: Float Array
       - Short Option:F
       - Long Option:float-array
       - Default: None
       - Units: kg
     
     
     Simple array of floats.  This shows having units
     */
    std::vector<float> floatArray;
    /** @} */ // End of floatArray group

    ////////////////////////////////////////
    //  Catagory: strings
    ////////////////////////////////////////


    ////////////////////
    /** @defgroup myString FIX: add short description here
Simple string
    @{
    */
public:
    /*!
     @brief FIX: add short description here
     
     Attributes:
       - Name: myString
       - Short Option:s
       - Long Option:string
       - Default: 
       - Units: None
     
     
     Simple string
     */
    std::string myString;
    /** @} */ // End of myString group

    ////////////////////
    /** @defgroup myStringDefault An example of string that comes with a default
Simple string
    @{
    */
public:
    /*!
     @brief An example of string that comes with a default
     
     Attributes:
       - Name: My Str With Dflt
       - Short Option:d
       - Long Option:stringDefault
       - Default: Some default string
       - Units: None
     
     
     Simple string
     */
    std::string myStringDefault;
    /** @} */ // End of myStringDefault group

    ////////////////////
    /** @defgroup stringArray Array of strings.  Can have also have no entries.
Simple array of strings
    @{
    */
public:
    inline void appendStringarray(const std::string &newVal) {stringArray.push_back(newVal);} ///< Add an entry on the end
    inline void    popStringarray() {stringArray.pop_back();} ///< Remove last entry
    inline void   sizeStringarray() {stringArray.size();} ///< Length of the array
    /*!
     @brief Array of strings.  Can have also have no entries.
     
     Attributes:
       - Name: String Array
       - Short Option:S
       - Long Option:string-array
       - Default: None
       - Units: None
     
     
     Simple array of strings
     */
    std::vector<std::string> stringArray;
    /** @} */ // End of stringArray group
}; // class AllTypes
#endif // _ALLTYPES_H_ // include guard
